<?php
/*
 *      Copyright 2007 by Dag Erlandsson (langarod@gmail.com)
 *      This software is distributed under the GNU public license version 2
*/

  include("config.inc");

  $command = trim($_GET['command']);

  $delay = (int)trim($_GET['delay']);
  if($delay < 10 || $delay > 10000)
    $delay = 1000;

  $startTime = 0;
  if(ereg("([0-9]{2}):([0-9]{2})", $_GET['time'], $regs))
    $startTime = $regs[1]*60 + $regs[2]; // in minutes past 00:00

  $frame = (int)trim($_GET['frame']);
  if(!isset($frame))
    $frame = 0;

  $frameStep = (int)trim($_GET['step']);
  if($frameStep < 1 || frameStep > 10)
    $frameStep = 1;

  $feed = trim($_GET['feed']);
  $date = trim($_GET['date']);
  if(isset($feed, $date))
  {
    $path_to_images = "$image_root/$feed/$date/";
  }

  if(!isset($path_to_images))
    die('Feed and Date not defined');

  $motionMode = false;
  if( trim($_GET['mode']) == 'motion')
    $motionMode = true;

  if($motionMode)
    $filePattern = "/[0-9]m\.(jpg|jpeg|gif|png)$/i";
  else
    $filePattern = "/[0-9]\.(jpg|jpeg|gif|png)$/i";

  $dh = opendir( "$path_to_images" );
  $filenames = array();
  while( $file = readdir( $dh ) ) 
  {
    // look for these file types....
    if (preg_match($filePattern, $file)) 
    {
      $filenames[] = $file;
    }
  }
  sort($filenames);
  
  // Find Frame with time >= StartTime
  $timeFrame = 0;
  if($startTime > 0)
  {
    $timeFrame = count($filenames) - 1;
    for ($i = 0; $i < count($filenames); $i++)
    {
      if(ereg('([0-9]{2})([0-9]{2})([0-9]{2})', $filenames[$i], $regs))
      {
        if($regs[1]*60 + $regs[2] >= $startTime)
        {
          $timeFrame = $i;
          break;
        }
      }
    }
  }

  if($frame+$timeFrame > count($filenames) - 1)
  {
    $frame = count($filenames) - 1;
    $timeFrame = 0;
  }
  if($frame+$timeFrame < 0)
  {
    $frame = $timeFrame;
  }

  switch($command)
  {
    case 'fplay':
    case 'bplay':
/*
      header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");               // Date in the past
      header("Last-Modified: " . date("r "));                          // always modified
      header("Cache-Control: no-cache, must-revalidate");             // HTTP/1.1
      header("Pragma: no-cache");                                     // HTTP/1.0      
*/
      header('Content-type: multipart/x-mixed-replace;boundary=BoundaryString');
      echo "\n--BoundaryString\n";
      for ($i = $frame + $timeFrame; 
             ($command=='fplay') ? $i < count($filenames) : $i >= 0;
             ($command=='fplay') ? $i+=$frameStep : $i-=$frameStep
          )
      {
        // open the file in a binary mode
        $fp = fopen($path_to_images.$filenames[$i], 'rb');

        echo "Content-type: image/jpeg\n";
        echo "Content-Length: " . filesize($path_to_images.$filenames[$i]). "\n\n";

        // dump the picture
        fpassthru($fp);
        fclose($fp);

        echo "\n--BoundaryString\n";
        ob_flush();
        flush();

        usleep($delay*1000); // us
      }
      echo "\n--endofsection--";
    break;

    case '':
    default:
      header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");               // Date in the past
      header("Last-Modified: " . date("r "));                          // always modified
      header("Cache-Control: no-cache, must-revalidate");             // HTTP/1.1
      header("Pragma: no-cache");                                     // HTTP/1.0      

      header("Content-type: image/jpeg\n\n");

      $fp = fopen($path_to_images.$filenames[$frame+$timeFrame], 'rb');
      fpassthru($fp);
      fclose($fp);
    break;

    case 'singleSteam':
    default:

/*
      header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");               // Date in the past
      header("Last-Modified: " . date("r "));                          // always modified
      header("Cache-Control: no-cache, must-revalidate");             // HTTP/1.1
      header("Pragma: no-cache");                                     // HTTP/1.0      
*/
      header('Content-type: multipart/x-mixed-replace;boundary=BoundaryString');
      echo "\n--BoundaryString\n";
      $fp = fopen($path_to_images.$filenames[$frame+$timeFrame], 'rb');
      echo "Content-type: image/jpeg\n";
      echo "Content-Length: " . filesize($path_to_images.$filenames[$frame+$timeFrame]) . "\n\n";
      fpassthru($fp);
      fclose($fp);

      echo "\n--BoundaryString\n";
      $fp = fopen($path_to_images.$filenames[$frame+$timeFrame], 'rb');
      echo "Content-type: image/jpeg\n";
      echo "Content-Length: " . filesize($path_to_images.$filenames[$frame+$timeFrame]). "\n\n";
      fpassthru($fp);
      fclose($fp);
      echo "\n--BoundaryString--\n";
    break;
  }
?>
